/*
 * Copyright 2023 Li.Xionghui Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <stdio.h>
#include <stdint.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include "elang.h"
const char* banner = "\
   _____     _                  _                _            \n\
  (_____)   (_)                | |              (_)      _    \n\
     _ _   _ _  ____ ____       \\ \\   ____  ____ _ ____ | |_  \n\
    | | | | | |/ ___) _  )       \\ \\ / ___)/ ___) |  _ \\|  _) \n\
 ___| | |_| | ( (__( (/ /    _____) | (___| |   | | | | | |__ \n\
(____/ \\____|_|\\____)____)  (______/ \\____)_|   |_| ||_/ \\___)\n\
                                                  |_|         \n\
                                           --juicemail@163.com\n";

int main(const int argc,const char** argv){
    void* vm;
    void** vm_p = &vm;
    el_uint32_t item;
    el_uint32_t size;

    printf("%s",banner);
    printf("Elang boot...\n");
    
    char src_file_buff[10*1024] = {"a=12;"};
    // printf("*********************** elang_ext_new_state **************************************\n");
    elang_ext_new_state(vm_p);
    // printf("*********************** elang_ext_boot_hook **************************************\n");
    elang_ext_boot_hook(vm);
{
    // strcpy(src_file_buff,"a=12;b=123;");
    // strcpy(src_file_buff,"l = {123,\"123\",\"string\"};print(l[0]);");
    strcpy(src_file_buff,"l = {123,\"123\",\"Hello JuiceScript!!!\"};print(l[0]);;print(l[1]);;print(l[2]);");
    elang_ext_set_code(vm_p,src_file_buff);
    elang_ext_run(vm_p);
    elang_ext_get_mem_used(vm_p,&item,&size);
    printf("item: %d size: %d Bytes\n",item,size);
}
    elang_ext_exit_hook(vm);
}